<?php
/*
		++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		++ Mp3 Id Tag Editor Powered By Oms4all in scriptcamp Group ++
		++ Contact Us : scriptcamp.ir@gmail.com                     ++
		++              scriptcamp.ir@gmail.com                 ++
		++ Tel me :     0938 506 32 23                          ++
		++ www.scriptcamp.ir is best free PHP Script                ++
		++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

*/
class getID3_cached_dbm extends getID3
{

	function getID3_cached_dbm($cache_type, $dbm_filename, $lock_filename) {

		// Check for dba extension
		if (!extension_loaded('dba')) {
			die('PHP is not compiled with dba support, required to use DBM style cache.');
		}

		// Check for specific dba driver
		if (function_exists('dba_handlers')) {  // PHP 4.3.0+
			if (!in_array('db3', dba_handlers())) {
				die('PHP is not compiled --with '.$cache_type.' support, required to use DBM style cache.');
			}
		}
		else { // PHP <= 4.2.3
			ob_start(); // nasty, buy the only way to check...
			phpinfo();
			$contents = ob_get_contents();
			ob_end_clean();
			if (!strstr($contents, $cache_type)) {
				die('PHP is not compiled --with '.$cache_type.' support, required to use DBM style cache.');
			}
		}

		// Create lock file if needed
		if (!file_exists($lock_filename)) {
			if (!touch($lock_filename)) {
				die('failed to create lock file: ' . $lock_filename);
			}
		}

		// Open lock file for writing
		if (!is_writeable($lock_filename)) {
			die('lock file: ' . $lock_filename . ' is not writable');
		}
		$this->lock = fopen($lock_filename, 'w');

		// Acquire exclusive write lock to lock file
		flock($this->lock, LOCK_EX);

		// Create dbm-file if needed
		if (!file_exists($dbm_filename)) {
			if (!touch($dbm_filename)) {
				die('failed to create dbm file: ' . $dbm_filename);
			}
		}

		// Try to open dbm file for writing
		$this->dba = @dba_open($dbm_filename, 'w', $cache_type);
		if (!$this->dba) {

			// Failed - create new dbm file
			$this->dba = dba_open($dbm_filename, 'n', $cache_type);

			if (!$this->dba) {
				die('failed to create dbm file: ' . $dbm_filename);
			}

			// Insert getID3 version number
			dba_insert(GETID3_VERSION, GETID3_VERSION, $this->dba);
		}

		// Init misc values
		$this->cache_type   = $cache_type;
		$this->dbm_filename = $dbm_filename;

		// Register destructor
		register_shutdown_function(array($this, '__destruct'));

		// Check version number and clear cache if changed
		if (dba_fetch(GETID3_VERSION, $this->dba) != GETID3_VERSION) {
			$this->clear_cache();
		}

		parent::getID3();
	}



	// public: destuctor
	function __destruct() {

		// Close dbm file
		@dba_close($this->dba);

		// Release exclusive lock
		@flock($this->lock, LOCK_UN);

		// Close lock file
		@fclose($this->lock);
	}



	// public: clear cache
	function clear_cache() {

		// Close dbm file
		dba_close($this->dba);

		// Create new dbm file
		$this->dba = dba_open($this->dbm_filename, 'n', $this->cache_type);

		if (!$this->dba) {
			die('failed to clear cache/recreate dbm file: ' . $this->dbm_filename);
		}

		// Insert FarcoID3 version number
		dba_insert(GETID3_VERSION, GETID3_VERSION, $this->dba);

		// Reregister shutdown function
		register_shutdown_function(array($this, '__destruct'));
	}



	// public: analyze file
	function analyze($filename) {

		if (file_exists($filename)) {

			// Calc key     filename::mod_time::size    - should be unique
			$key = $filename . '::' . filemtime($filename) . '::' . filesize($filename);

			// Loopup key
			$result = dba_fetch($key, $this->dba);

			// Hit
			if ($result !== false) {
				return unserialize($result);
			}
		}

		// Miss
		$result = parent::analyze($filename);

		// Save result
		if (file_exists($filename)) {
			dba_insert($key, serialize($result), $this->dba);
		}

		return $result;
	}

}


?>